<template>
  <article class="product" v-if="gridViewStyle">
    <div class="thumbnail" :style="{ backgroundImage: `url(${baseUrl}/${product.thumbnail})` }">
      <p class="short-desc">{{ product.shortDescription }}</p>
      <nuxt-link :to="`/shop/product/${product.id}`">
        <Button class="more-button" color="primary" type="contained">توضیحات بیشتر</Button>
      </nuxt-link>
    </div>
    <div class="info">
      <div class="header">
        <nuxt-link :to="`/shop/product/${product.id}`">
          <h3 class="title">{{ product.title }}</h3>
        </nuxt-link>
        <div class="header-tags">
          <nuxt-link :to="`/shop/category/${product.category.id}`" v-if="product.category">
            <Chip class="category" small>
              <div class="category-text">{{ product.category.title }}</div>
            </Chip>
          </nuxt-link>
          <Chip
            outline
            small
            class="sale-label"
            primary
            v-if="product.off"
            v-ripple="'rgba(230, 179, 30, 0.2)'"
          >
            <template #icon>
              <OfferIcon />
            </template>
            <div class="sale-label-text">٪{{product.off}} تخفیف</div>
          </Chip>
        </div>
      </div>
      <div class="footer">
        <div class="price-info-container">
          <div class="price-container price-container--off" v-if="product.off">
            <p class="price price--off">{{ product.price | formatPrice }}</p>
            <p class="price-unit">تومان</p>
          </div>
          <div class="price-container">
            <p class="price">{{ getPrice | formatPrice }}</p>
            <p class="price-unit">تومان</p>
          </div>
        </div>
        <Button type="text" round color="white" icon="shopping_cart" class="cart" size="sm" @click.native="addToCart">
          <template #icon>
            <CartIcon />
          </template>
        </Button>
      </div>
    </div>
  </article>
  <!-- LIST VIEW STYLE -->
  <article v-else class="product--list">
    <nuxt-link :to="`/shop/product/${product.id}`" class="thumbnail-link thumbnail-link--list">
      <div
        class="thumbnail--list"
        v-ripple
        :style="{ backgroundImage: `url(${baseUrl}/${product.thumbnail})` }"
      ></div>
    </nuxt-link>
    <div class="info--list">
      <router-link :to="`/shop/product/${product.id}`">
        <h3 class="title title--list">{{product.title}}</h3>
      </router-link>
      <p class="short-desc--list">{{product.shortDescription}}</p>
      <div class="info-footer--list">
        <div class="info-footer-right--list">
          <div class="price-container price-container--list price-container--off" v-if="product.off">
            <p class="price--list price--off">{{product.price | formatPrice}}</p>
            <p class="price-unit--list">تومان</p>
          </div>
          <div class="price-container price-container--list">
            <p class="price--list">{{getPrice | formatPrice}}</p>
            <p class="price-unit--list">تومان</p>
          </div>
        </div>
        <div class="info-footer-left--list">
          <Chip
            outline
            small
            class="sale-label--list"
            primary
            v-if="product.off"
            v-ripple="'rgba(230, 179, 30, 0.2)'"
          >
            <template #icon>
              <OfferIcon />
            </template>
            <div class="sale-label-text">٪{{product.off}} تخفیف</div>
          </Chip>
          <nuxt-link :to="`/shop/category/${product.category.id}`" v-if="product.category">
            <Chip small class="category--list">
              <div class="category-text--list">{{product.category.title}}</div>
            </Chip>
          </nuxt-link>
        </div>
      </div>
    </div>
    <div class="actions--list">
      <Button type="outlined" color="primary" class="cart--list" @click.native="addToCart">
        <template #icon>
          <CartIcon class="cart-icon--list"/>
        </template>
        افزودن به سبد خرید
      </Button>
    </div>
  </article>
</template>

<script>
import numeral from "numeral";
import Button from "@/components/base/Button";
import Chip from "@/components/base/Chip";
import CartIcon from "@/assets/svgs/cart.svg";
import OfferIcon from "@/assets/svgs/offer.svg";

export default {
  name: "Product",
  components: {
    Button,
    Chip,
    CartIcon,
    OfferIcon
  },
  data() {
    return {
      baseUrl: process.env.baseUrl
    }
  },
  props: {
    product: {
      type: Object,
      required: true
    },
    gridViewStyle: {
      type: Boolean,
      default: true
    }
  },
  filters: {
    formatPrice(val) {
      return numeral(val).format("0,0");
    }
  },
  computed: {
    getPrice() {
      return (this.product.price * (100 - this.product.off)) / 100;
    }
  },
  methods: {
    addToCart() {
      this.$store.dispatch('cart/push', this.product.id).then(response => {
        this.$store.dispatch('notifications/push', {
          type: 'success',
          light: true,
          message: 'به سبد خرید اضافه شد.'
        });
      }).catch(error => {
        if (error === "quantity") {
          this.$store.dispatch('notifications/push', {
            type: 'warning',
            light: true,
            message: 'در انبار موجود نمی باشد.'
          });
        } else {
          this.$router.push('/register');
        }
      });
    }
  }
};
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables';

/* GENERAL */
.price--off
  text-decoration line-through


/* GRID VIEW */
.product 
  width $product-width
  background-color $black-lighter
  box-shadow $product-shadow
  border-radius $product-border-radius
  display flex
  flex-direction column
  overflow hidden
  color $white
  transition all 0.1s ease-out
  &:hover
    box-shadow $product-shadow-raised
    transform scale($product-scale-raised)
  &--list
    color $white
    align-items center
    direction rtl
    transition all 0.2s
    display flex
    align-items center
    flex-wrap wrap
    @media only screen and (max-width: 900px)
      flex-direction column

.thumbnail 
  background-size cover
  background-position center
  height $product-thumbnail-height
  display flex
  justify-content center
  flex-direction column
  align-items center
  padding $product-thumbnail-padding
  position relative
  z-index 1
  &::before
    position absolute
    top 0
    left 0
    width 100%
    height 100%
    z-index 1
    content ""
    background-color black
    opacity 0
    transition all 0.2s
  &--list
    width: $product-listed-thumbnail-size
    height: $product-listed-thumbnail-size
    position relative
    border-radius $product-border-radius
    background-size cover
    background-position center
    @media only screen and (max-width: 900px)
      border-radius 0
      width 100%
      height: $product-listed-thumbnail-size * 2
    @media only screen and (max-width: 650px)
      height: $product-listed-thumbnail-size * 1.7
    @media only screen and (max-width: 520px)
      height: $product-listed-thumbnail-size * 1.3
    @media only screen and (max-width: 480px)
      height: $product-listed-thumbnail-size * 1

.thumbnail-link 
  &--list
    @media only screen and (max-width: 900px)
      width 100%

.product:hover .thumbnail::before
  opacity 0.6

.product:hover .short-desc,
.product:hover .more-button
  opacity 1

.category 
  direction ltr
  align-self end
  margin 0
  padding $product-category-padding
  position relative
  z-index 3
  margin $product-category-margin
  opacity 0.75
  &--list
    direction ltr
    padding-left $xsm
    opacity 0.75

.short-desc 
  font-size $product-short-desc-font-size
  text-align center
  margin $product-short-desc-margin
  transition all 0.2s
  opacity 0
  position relative
  z-index 3
  &--list
    font-size $font-size
    margin-top $xsm
    opacity 0.5
    @media only screen and (max-width: 480px)
      font-size $font-size--sm

.more-button
  transition all 0.2s
  opacity 0
  position relative
  z-index 3
  font-weight 300

.info
  padding $product-info-padding
  direction rtl
  &--list
    margin-right $lg
    margin-left auto
    max-width 55rem
    @media only screen and (max-width: 1300px)
      max-width 45rem
    @media only screen and (max-width: 1200px)
      max-width none
      width calc(100% - 25rem)
    @media only screen and (max-width: 900px)
      margin-right 0
      margin-top $md
      width 100%


.title
  font-weight 500
  font-size $product-title-font-size
  transition all 0.2s
  position relative
  padding $product-title-padding
  &:hover
    color $primary
    cursor pointer
  &--list
    font-size $product-listed-title-font-size
    padding 0
    @media only screen and (max-width: 480px)
      font-size $product-listed-title-font-size--sm

.header
  padding $product-header-padding
  border-bottom $product-header-border-bottom
  display flex
  flex-direction column

.header-tags
  display flex
  flex-direction row-reverse
  padding $product-header-tags-padding
  align-items center

.footer
  display flex
  align-items center
  padding $product-footer-padding

.price-container
  display flex
  align-items center
  &--list
    margin-left $md
    &:not(:first-of-type)
      margin $product-listed-price-container-margin
    @media only screen and (max-width: 480px)
      font-size $font-size--sm
  &--off
    color $primary
    opacity 0.5

.price 
  font-size $product-price-font-size

.price-unit
  font-size $product-price-font-size
  margin $product-price-unit-margin
  &--list
    font-size $font-size
    margin 0 $xsm 0 0

.cart
  margin-right auto
  &--list
    direction ltr

/* LIST VIEW */
.actions
  &--list
    display flex
    flex-direction row-reverse
    align-items center
    @media only screen and (max-width: 1200px)
      margin-top $md
      width 100%
      & > *
        width 100%

.sale-label--list
  margin-left $sm

.sale-label-text 
  direction rtl

.info-footer--list
  display flex
  margin-top $sm
  align-items stretch
  justify-content space-between
  @media only screen and (max-width: 575px)
    flex-direction column-reverse

.info-footer-left--list
  display flex
  align-items flex-start
  @media only screen and (max-width: 575px)
    margin-bottom $sm
    align-self flex-end

.category-text--list
  direction rtl

.cart-icon--list
  fill $primary
</style>

